import React from 'react';
import { ViewStyle, TextStyle } from 'react-native';
import { Ionicons } from '@expo/vector-icons';

type InputFileProps = {
    selectedFiles?: () => void;
    multiple?: boolean;
    previewFiles?: boolean;
    typeFiles?: 'images' | 'pdf' | 'all';
    copyToCacheDirectory?: boolean;
    onChange?: (dataFiles?: FileSelectedType[]) => void;
    label?: string;
    typeInputFile?: "container" | "button";
    required?: boolean;
    onRemoveFile?: (indexFile: number) => void;
    noConcatenation?: boolean;
};
type InputFileContainerProps = {
    typeInputFile: "container";
    containerStyle?: ViewStyle;
    labelContainer?: TextStyle;
} & InputFileProps;
type InputFileButtonProps = {
    typeInputFile: "button";
    buttonStyle?: ViewStyle;
    labelButtonStyle?: TextStyle;
    disabled?: boolean;
    isLoading?: boolean;
    iconSize?: number;
    colorLoading?: string;
    icon?: keyof typeof Ionicons.glyphMap;
    iconColor?: string;
} & InputFileProps;
type FileSelectedType = {
    mimeType: string;
    uri: string;
    fileSize: number;
    fileName: string;
};
declare const MediaTypes: {
    images: string;
    pdf: string;
    all: string;
};
type ButtonProps = {
    colorLoading?: string;
    icon?: keyof typeof Ionicons.glyphMap;
    iconColor?: string;
    label?: string;
    onPress: () => void;
    contentStyle?: ViewStyle;
    labelStyle?: TextStyle;
    disabled?: boolean;
    isLoading?: boolean;
    iconSize?: number;
};
type ContainerProps = {
    containerStyle?: ViewStyle;
    labelContainer?: TextStyle;
    onPress?: () => void;
    label: string;
    iconColor: string;
    required?: boolean;
};
type CardAttachmentProps = {
    name: string;
    type: string;
    linkAttachment: string;
    downloadFile?: boolean;
    onRemove?: () => void;
    horizontal?: boolean;
    withIcon?: boolean;
    isLoading?: boolean;
};
declare const formatImages: string[];
declare const formatPdf: string[];
declare const get_url_extension: (url: string) => string | undefined;

declare const InputFile: React.FC<InputFileContainerProps | InputFileButtonProps>;

export { type ButtonProps, type CardAttachmentProps, type ContainerProps, type FileSelectedType, InputFile, type InputFileButtonProps, type InputFileContainerProps, MediaTypes, formatImages, formatPdf, get_url_extension };
