var __getOwnPropNames = Object.getOwnPropertyNames;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};

// src/assets/images/pdf.png
var require_pdf = __commonJS({
  "src/assets/images/pdf.png"(exports, module) {
    module.exports = "./pdf-DRLKBAV4.png";
  }
});

// src/assets/images/file.png
var require_file = __commonJS({
  "src/assets/images/file.png"(exports, module) {
    module.exports = "./file-7YLA65K6.png";
  }
});

// src/assets/images/attachment.png
var require_attachment = __commonJS({
  "src/assets/images/attachment.png"(exports, module) {
    module.exports = "./attachment-KGXTGNAI.png";
  }
});

// src/components/InputFile.tsx
import React9 from "react";
import { StyleSheet as StyleSheet8 } from "react-native";

// src/components/PreviewFilesSelected.tsx
import React6 from "react";
import { FlatList, View as View3 } from "react-native";

// src/components/CardAttachment.tsx
import React5 from "react";
import { StyleSheet as StyleSheet5, Text as Text3, TouchableOpacity, View as View2 } from "react-native";

// src/components/ViewerFiles.tsx
import React3 from "react";
import { Dimensions, StyleSheet as StyleSheet3, Text as Text2 } from "react-native";
import { BottomSheet } from "react-native-sheet";

// src/components/types.ts
var MediaTypes = {
  images: "image/*",
  pdf: "pdf/*",
  all: "*/*"
};
var formatImages = ["gif", "png", "bmp", "jpeg", "jpg"];
var formatPdf = ["pdf"];
var get_url_extension = (url) => {
  if (!url)
    return "";
  return url.split(/[#?]/)[0].split(".").pop()?.trim();
};

// src/components/ViewerImage.tsx
import React2 from "react";
import ImageView from "react-native-image-viewing";
import { View } from "react-native";

// src/components/Button.tsx
import React from "react";
import { Pressable, StyleSheet as StyleSheet2, ActivityIndicator, Text } from "react-native";

// src/components/styles.ts
import { StyleSheet } from "react-native";
var Styles = StyleSheet.create({
  button: {
    padding: 16,
    width: "100%",
    borderRadius: 10,
    marginVertical: 4,
    flexDirection: "row",
    alignItems: "center",
    justifyContent: "center"
  },
  labelButton: {
    fontSize: 16,
    textAlign: "center",
    marginHorizontal: 4
  },
  containerFileType: {
    borderRadius: 8,
    padding: 20,
    borderWidth: 1,
    borderColor: "#EBEBEB",
    justifyContent: "center",
    alignItems: "center"
  },
  labelContainer: {
    fontSize: 16,
    color: "black"
  }
});

// src/components/Button.tsx
import { Ionicons } from "@expo/vector-icons";
var Button = ({ label, onPress, icon, labelStyle, colorLoading, iconColor = "black", iconSize = 20, isLoading, disabled, contentStyle }) => {
  return /* @__PURE__ */ React.createElement(Pressable, { onPress, style: StyleSheet2.flatten([Styles.button, contentStyle, disabled && { backgroundColor: "#E9E7E7" }]) }, icon && /* @__PURE__ */ React.createElement(
    Ionicons,
    {
      name: icon,
      size: iconSize,
      color: iconColor
    }
  ), isLoading && /* @__PURE__ */ React.createElement(ActivityIndicator, { size: "small", color: colorLoading ?? iconColor }), label && /* @__PURE__ */ React.createElement(Text, { style: [Styles.labelButton, labelStyle, disabled && { color: "#ADADAD" }] }, label));
};
var Button_default = Button;

// src/components/ViewerImage.tsx
var ViewerImage = ({
  source,
  visible,
  onClose,
  onLongPress
}) => {
  return /* @__PURE__ */ React2.createElement(
    ImageView,
    {
      images: [source],
      imageIndex: 0,
      visible,
      doubleTapToZoomEnabled: true,
      onRequestClose: () => onClose && onClose(),
      FooterComponent: () => /* @__PURE__ */ React2.createElement(View, { style: { paddingVertical: 20 } }, /* @__PURE__ */ React2.createElement(
        Button_default,
        {
          onPress: () => onLongPress && onLongPress(),
          icon: "share-outline",
          iconColor: "white",
          iconSize: 35
        }
      ))
    }
  );
};
var ViewerImage_default = ViewerImage;

// src/components/ViewerFiles.tsx
var { height: heightScreen } = Dimensions.get("screen");
var ViewerFiles = ({
  typeFile,
  url,
  visible,
  onClose
}) => {
  const isImage = formatImages.includes(typeFile);
  const bottomSheet = React3.useRef(null);
  React3.useEffect(() => {
    if (visible) {
      bottomSheet.current?.show();
    } else {
      bottomSheet.current?.hide();
    }
  }, [visible]);
  if (isImage) {
    return /* @__PURE__ */ React3.createElement(
      ViewerImage_default,
      {
        visible,
        source: { uri: url },
        onClose: () => onClose && onClose()
      }
    );
  }
  return /* @__PURE__ */ React3.createElement(
    BottomSheet,
    {
      height: heightScreen,
      ref: bottomSheet,
      draggable: false,
      sheetStyle: { backgroundColor: "white" }
    },
    /* @__PURE__ */ React3.createElement(Text2, { style: styles.textUnsupport }, "Sorry, unsupported media type")
  );
};
var styles = StyleSheet3.create({
  contentModal: {
    padding: 24,
    flexDirection: "column",
    alignItems: "center"
  },
  textUnsupport: {
    fontSize: 14
  },
  labelsButtonPdf: {
    fontSize: 14
  },
  buttonClose: {
    borderRadius: 8,
    margin: 12,
    width: 40,
    padding: 4,
    borderColor: "black",
    borderWidth: 1
  },
  buttonDownload: {
    flex: 1,
    borderRadius: 8,
    margin: 12,
    padding: 4,
    borderColor: "black",
    borderWidth: 1
  },
  contentClose: {
    marginTop: 12,
    flexDirection: "row",
    alignItems: "center",
    justifyContent: "flex-end",
    width: "100%"
  }
});
var ViewerFiles_default = ViewerFiles;

// src/components/CardAttachment.tsx
import { Ionicons as Ionicons2 } from "@expo/vector-icons";

// src/components/GetIconType.tsx
import React4 from "react";
import { Image, StyleSheet as StyleSheet4 } from "react-native";

// src/assets/images/index.ts
var images = {
  pdfIcon: require_pdf(),
  fileIcon: require_file(),
  attachmentIcon: require_attachment()
};

// src/components/GetIconType.tsx
var GetIconType = ({ type, imageUrl }) => {
  const isImage = type ? formatImages.includes(type) : false;
  const isPdf = type ? formatPdf.includes(type) : false;
  if (isImage && !!imageUrl) {
    return /* @__PURE__ */ React4.createElement(Image, { source: { uri: imageUrl }, style: styles2.sizeIcons });
  }
  if (isPdf) {
    return /* @__PURE__ */ React4.createElement(Image, { resizeMode: "contain", source: images.pdfIcon, style: styles2.sizeIcons });
  }
  return /* @__PURE__ */ React4.createElement(Image, { resizeMode: "contain", source: images.fileIcon, style: styles2.sizeIcons });
};
var styles2 = StyleSheet4.create({
  sizeIcons: { width: 20, height: 20, marginRight: 10 }
});
var GetIconType_default = GetIconType;

// src/components/CardAttachment.tsx
var CardAttachment = ({
  name,
  type,
  linkAttachment,
  onRemove,
  horizontal = false,
  withIcon = false
}) => {
  const [visibleViewer, setVisibleViewer] = React5.useState(false);
  const handleShowImage = () => {
    setVisibleViewer(true);
  };
  return /* @__PURE__ */ React5.createElement(React5.Fragment, null, /* @__PURE__ */ React5.createElement(
    TouchableOpacity,
    {
      activeOpacity: 1,
      onPress: handleShowImage,
      style: horizontal ? styles3.containerCardHorizontal : styles3.containerCard
    },
    /* @__PURE__ */ React5.createElement(View2, { style: horizontal ? styles3.contentHorizontal : styles3.content }, withIcon && /* @__PURE__ */ React5.createElement(GetIconType_default, null), /* @__PURE__ */ React5.createElement(Text3, { style: styles3.textName, numberOfLines: 2 }, name), onRemove && /* @__PURE__ */ React5.createElement(
      TouchableOpacity,
      {
        style: { marginLeft: 2 },
        onPress: () => onRemove?.()
      },
      /* @__PURE__ */ React5.createElement(
        Ionicons2,
        {
          name: "close-circle-outline",
          size: 30,
          color: "#1F3552"
        }
      )
    ))
  ), /* @__PURE__ */ React5.createElement(
    ViewerFiles_default,
    {
      typeFile: type,
      url: linkAttachment,
      visible: visibleViewer,
      onClose: () => setVisibleViewer(false)
    }
  ));
};
var styles3 = StyleSheet5.create({
  containerCard: {
    width: "100%",
    backgroundColor: "white",
    marginVertical: 2,
    paddingHorizontal: 5,
    paddingVertical: 10,
    borderRadius: 5
  },
  containerCardHorizontal: {
    backgroundColor: "white",
    borderRadius: 5,
    width: 220
  },
  contentHorizontal: {
    flexDirection: "row",
    alignItems: "center",
    justifyContent: "flex-start"
  },
  content: {
    flexDirection: "row",
    alignItems: "center",
    justifyContent: "space-between"
  },
  textName: {
    fontSize: 16,
    color: "#5E9CEF",
    fontWeight: "500",
    width: "80%"
  }
});
var CardAttachment_default = CardAttachment;

// src/components/PreviewFilesSelected.tsx
var PreviewFilesSelected = ({
  files,
  onRemove,
  disabledChanges,
  statusUploadingFile
}) => {
  const renderFiles = ({ item, index }) => {
    const extensionAttachment = get_url_extension(item.uri.toLowerCase());
    if (!extensionAttachment)
      return null;
    return /* @__PURE__ */ React6.createElement(
      CardAttachment_default,
      {
        name: item.fileName,
        type: extensionAttachment,
        linkAttachment: item.uri,
        downloadFile: false,
        onRemove: () => !disabledChanges && onRemove(index),
        isLoading: statusUploadingFile === "uploading"
      }
    );
  };
  return /* @__PURE__ */ React6.createElement(View3, { style: { width: "100%", marginBottom: 10 } }, /* @__PURE__ */ React6.createElement(
    FlatList,
    {
      data: files,
      keyExtractor: (_, index) => `file-preview-${index}`,
      renderItem: renderFiles,
      scrollEnabled: false,
      nestedScrollEnabled: true
    }
  ));
};
var PreviewFilesSelected_default = PreviewFilesSelected;

// src/components/ModalOptionsUploadFile.tsx
import { View as View4, StyleSheet as StyleSheet6 } from "react-native";
import React7 from "react";
import * as ImagePicker from "expo-image-picker";
import * as DocumentPicker from "expo-document-picker";

// src/utils/index.ts
var getNameImagePicker = (uri) => {
  const str = uri.split("/");
  return str[str.length - 1] ?? `imagePicker${Math.random()}`;
};
var mapperDataFiles = (dataFile, dataImage) => {
  if (dataFile && dataFile.canceled === false) {
    return dataFile.assets.map((file) => ({
      mimeType: file.mimeType ?? "",
      uri: file.uri,
      fileSize: file.size ?? 30,
      fileName: file.name
    }));
  }
  if (!dataImage)
    return [];
  return dataImage.map((asset) => ({
    mimeType: asset.type ?? "Image",
    uri: asset.uri,
    fileSize: asset.fileSize ?? 20,
    fileName: getNameImagePicker(asset.uri)
  }));
};

// src/components/ModalOptionsUploadFile.tsx
var ModalOptionsUploadFile = ({
  files,
  setFiles,
  openModal,
  onOpenModal,
  multiple,
  typeFiles = "all",
  copyToCacheDirectory = false,
  noConcatenation = false
}) => {
  const [cameraPermissionStatus, setCameraPermissionStatus] = React7.useState("undetermined");
  const typeMedia = MediaTypes[typeFiles];
  React7.useEffect(() => {
    ImagePicker.getCameraPermissionsAsync().then(({ status }) => {
      if (status !== "granted") {
        requestCameraPermission().catch((err) => console.log("Camera permission error::", err));
      }
    });
  }, []);
  const requestCameraPermission = async () => {
    const { status } = await ImagePicker.requestCameraPermissionsAsync();
    setCameraPermissionStatus(status);
  };
  const handlePickerFiles = () => {
    DocumentPicker.getDocumentAsync({
      multiple,
      copyToCacheDirectory,
      type: typeMedia
    }).then((data) => {
      if (data.canceled)
        return;
      const dataMap = mapperDataFiles(data);
      if (!multiple || noConcatenation) {
        setFiles(dataMap);
        return;
      }
      setFiles([...files, ...dataMap]);
    });
  };
  const dontPermit = () => {
    requestCameraPermission().catch((err) => console.log("Camera permission error::", err));
  };
  const pickImage = (takePhoto = false) => {
    onOpenModal(false);
    const configPicker = {
      mediaTypes: ImagePicker.MediaTypeOptions.All,
      aspect: [4, 3],
      quality: 1,
      allowsMultipleSelection: multiple
    };
    if (takePhoto) {
      if (cameraPermissionStatus !== "granted") {
        return dontPermit();
      }
      ImagePicker.launchCameraAsync(configPicker).then((result) => {
        if (result.canceled)
          return;
        const dataMap = mapperDataFiles(void 0, result.assets);
        if (!multiple || noConcatenation) {
          setFiles(dataMap);
          return;
        }
        setFiles([...files, ...dataMap]);
      });
      return;
    }
    ImagePicker.launchImageLibraryAsync(configPicker).then((result) => {
      if (result.canceled)
        return;
      const dataMap = mapperDataFiles(void 0, result.assets);
      if (!multiple || noConcatenation) {
        setFiles(dataMap);
        return;
      }
      setFiles([...files, ...dataMap]);
    }).catch((error) => console.log("[launchImageLibraryAsync] error::", error));
  };
  if (!openModal)
    return null;
  return /* @__PURE__ */ React7.createElement(View4, { style: styles4.modalMenu }, typeFiles !== "pdf" && /* @__PURE__ */ React7.createElement(React7.Fragment, null, /* @__PURE__ */ React7.createElement(
    Button_default,
    {
      onPress: () => pickImage(),
      label: "Photo Library",
      labelStyle: { fontSize: 14, color: "#1F3552" },
      contentStyle: {
        paddingVertical: 5,
        alignItems: "center",
        justifyContent: "flex-start"
      }
    }
  ), /* @__PURE__ */ React7.createElement(
    Button_default,
    {
      onPress: () => pickImage(true),
      label: "Take Photo",
      labelStyle: { fontSize: 14, color: "#1F3552" },
      contentStyle: {
        paddingVertical: 5,
        alignItems: "center",
        justifyContent: "flex-start"
      }
    }
  )), /* @__PURE__ */ React7.createElement(
    Button_default,
    {
      onPress: () => {
        handlePickerFiles();
        onOpenModal(false);
      },
      label: "Choose Files",
      labelStyle: { fontSize: 14, color: "#1F3552" },
      contentStyle: {
        paddingVertical: 5,
        alignItems: "center",
        justifyContent: "flex-start"
      }
    }
  ));
};
var styles4 = StyleSheet6.create({
  modalMenu: {
    padding: 10,
    shadowOffset: {
      width: 0,
      height: 8
    },
    elevation: 16,
    shadowRadius: 16,
    shadowColor: "rgba(47, 51, 80, 0.12)",
    shadowOpacity: 1,
    borderTopLeftRadius: 12,
    borderTopRightRadius: 12,
    borderBottomRightRadius: 12,
    borderBottomLeftRadius: 12,
    bottom: 40,
    right: 10,
    backgroundColor: "white"
  }
});
var ModalOptionsUploadFile_default = ModalOptionsUploadFile;

// src/components/Container.tsx
import React8 from "react";
import { Ionicons as Ionicons3 } from "@expo/vector-icons";
import { StyleSheet as StyleSheet7, Text as Text4, TouchableOpacity as TouchableOpacity2 } from "react-native";
var Container = ({ containerStyle, onPress, labelContainer, label, iconColor = "\xB71F3552", required = false }) => {
  return /* @__PURE__ */ React8.createElement(
    TouchableOpacity2,
    {
      style: StyleSheet7.flatten([Styles.containerFileType, containerStyle]),
      activeOpacity: 1,
      onPress
    },
    /* @__PURE__ */ React8.createElement(Ionicons3, { name: "md-cloud-upload-outline", size: 24, color: iconColor }),
    /* @__PURE__ */ React8.createElement(Text4, { style: StyleSheet7.flatten([Styles.labelContainer, labelContainer]) }, label ?? "Upload", required && /* @__PURE__ */ React8.createElement(Text4, { style: { color: "red" } }, "*"))
  );
};
var Container_default = Container;

// src/components/InputFile.tsx
var InputFile = ({
  label,
  multiple = true,
  previewFiles = false,
  typeFiles = "all",
  onChange,
  typeInputFile: type = "button",
  onRemoveFile,
  required,
  noConcatenation = false,
  ...rest
}) => {
  const [filesSelected, setFilesSelected] = React9.useState([]);
  const [showModalMenu, setShowModalMenu] = React9.useState(false);
  const setFilesAssets = (fileAssets) => {
    setShowModalMenu(false);
    setFilesSelected(fileAssets);
    onChange?.(fileAssets);
  };
  const handleRemoveFile = (indexFile) => {
    setFilesSelected((prev) => {
      return prev.filter((_, index) => index !== indexFile);
    });
    onRemoveFile?.(indexFile);
  };
  const renderPreviewFiles = React9.useMemo(() => {
    if (!previewFiles || !filesSelected.length)
      return null;
    return /* @__PURE__ */ React9.createElement(
      PreviewFilesSelected_default,
      {
        files: filesSelected.reverse(),
        onRemove: handleRemoveFile
      }
    );
  }, [filesSelected]);
  return /* @__PURE__ */ React9.createElement(React9.Fragment, null, type === "button" ? /* @__PURE__ */ React9.createElement(
    Button_default,
    {
      onPress: () => setShowModalMenu(!showModalMenu),
      label: label ?? "Upload",
      labelStyle: StyleSheet8.flatten([{ color: "#1F3552" }, rest.labelButtonStyle]),
      contentStyle: StyleSheet8.flatten([{
        padding: 0,
        marginBottom: 30,
        justifyContent: "flex-start"
      }, rest.buttonStyle]),
      ...rest
    }
  ) : /* @__PURE__ */ React9.createElement(
    Container_default,
    {
      iconColor: "#1F3552",
      onPress: () => setShowModalMenu(!showModalMenu),
      label: label ?? "Upload",
      required,
      ...rest
    }
  ), renderPreviewFiles, /* @__PURE__ */ React9.createElement(
    ModalOptionsUploadFile_default,
    {
      setFiles: setFilesAssets,
      files: filesSelected,
      openModal: showModalMenu,
      onOpenModal: setShowModalMenu,
      typeFiles,
      multiple,
      noConcatenation
    }
  ));
};
var InputFile_default = InputFile;
export {
  InputFile_default as InputFile,
  MediaTypes,
  formatImages,
  formatPdf,
  get_url_extension
};
//# sourceMappingURL=index.mjs.map